package com.ywt.gapi.base.log;

import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;

/**
 * <pre>
 *医务通日志服务  // 对应 base-service 项目的 log.js 文件
 * </pre>
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.7.2-SNAPSHOT)",
    comments = "Source: log.proto")
public final class YWTLogServiceGrpc {

  private YWTLogServiceGrpc() {}

  public static final String SERVICE_NAME = "com.ywt.gapi.base.log.YWTLogService";

  // Static method descriptors that strictly reflect the proto.
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static final io.grpc.MethodDescriptor<com.ywt.gapi.base.log.SaveCommentLogRequest,
      com.ywt.gapi.base.log.SaveCommentLogResponse> METHOD_SAVE_COMMENT_LOG =
      io.grpc.MethodDescriptor.<com.ywt.gapi.base.log.SaveCommentLogRequest, com.ywt.gapi.base.log.SaveCommentLogResponse>newBuilder()
          .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
          .setFullMethodName(generateFullMethodName(
              "com.ywt.gapi.base.log.YWTLogService", "saveCommentLog"))
          .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
              com.ywt.gapi.base.log.SaveCommentLogRequest.getDefaultInstance()))
          .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
              com.ywt.gapi.base.log.SaveCommentLogResponse.getDefaultInstance()))
          .setSchemaDescriptor(new YWTLogServiceMethodDescriptorSupplier("saveCommentLog"))
          .build();
  @io.grpc.ExperimentalApi("https://github.com/grpc/grpc-java/issues/1901")
  public static final io.grpc.MethodDescriptor<com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest,
      com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse> METHOD_SAVE_OPEN_HIS_PUSH_API_LOG =
      io.grpc.MethodDescriptor.<com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest, com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse>newBuilder()
          .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
          .setFullMethodName(generateFullMethodName(
              "com.ywt.gapi.base.log.YWTLogService", "saveOpenHisPushApiLog"))
          .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
              com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest.getDefaultInstance()))
          .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
              com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse.getDefaultInstance()))
          .setSchemaDescriptor(new YWTLogServiceMethodDescriptorSupplier("saveOpenHisPushApiLog"))
          .build();

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static YWTLogServiceStub newStub(io.grpc.Channel channel) {
    return new YWTLogServiceStub(channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static YWTLogServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    return new YWTLogServiceBlockingStub(channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static YWTLogServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    return new YWTLogServiceFutureStub(channel);
  }

  /**
   * <pre>
   *医务通日志服务  // 对应 base-service 项目的 log.js 文件
   * </pre>
   */
  public static abstract class YWTLogServiceImplBase implements io.grpc.BindableService {

    /**
     * <pre>
     * 记录日志
     * </pre>
     */
    public void saveCommentLog(com.ywt.gapi.base.log.SaveCommentLogRequest request,
        io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveCommentLogResponse> responseObserver) {
      asyncUnimplementedUnaryCall(METHOD_SAVE_COMMENT_LOG, responseObserver);
    }

    /**
     * <pre>
     * 保存his外转处方日志
     * </pre>
     */
    public void saveOpenHisPushApiLog(com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest request,
        io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse> responseObserver) {
      asyncUnimplementedUnaryCall(METHOD_SAVE_OPEN_HIS_PUSH_API_LOG, responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            METHOD_SAVE_COMMENT_LOG,
            asyncUnaryCall(
              new MethodHandlers<
                com.ywt.gapi.base.log.SaveCommentLogRequest,
                com.ywt.gapi.base.log.SaveCommentLogResponse>(
                  this, METHODID_SAVE_COMMENT_LOG)))
          .addMethod(
            METHOD_SAVE_OPEN_HIS_PUSH_API_LOG,
            asyncUnaryCall(
              new MethodHandlers<
                com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest,
                com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse>(
                  this, METHODID_SAVE_OPEN_HIS_PUSH_API_LOG)))
          .build();
    }
  }

  /**
   * <pre>
   *医务通日志服务  // 对应 base-service 项目的 log.js 文件
   * </pre>
   */
  public static final class YWTLogServiceStub extends io.grpc.stub.AbstractStub<YWTLogServiceStub> {
    private YWTLogServiceStub(io.grpc.Channel channel) {
      super(channel);
    }

    private YWTLogServiceStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected YWTLogServiceStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new YWTLogServiceStub(channel, callOptions);
    }

    /**
     * <pre>
     * 记录日志
     * </pre>
     */
    public void saveCommentLog(com.ywt.gapi.base.log.SaveCommentLogRequest request,
        io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveCommentLogResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(METHOD_SAVE_COMMENT_LOG, getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     * 保存his外转处方日志
     * </pre>
     */
    public void saveOpenHisPushApiLog(com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest request,
        io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(METHOD_SAVE_OPEN_HIS_PUSH_API_LOG, getCallOptions()), request, responseObserver);
    }
  }

  /**
   * <pre>
   *医务通日志服务  // 对应 base-service 项目的 log.js 文件
   * </pre>
   */
  public static final class YWTLogServiceBlockingStub extends io.grpc.stub.AbstractStub<YWTLogServiceBlockingStub> {
    private YWTLogServiceBlockingStub(io.grpc.Channel channel) {
      super(channel);
    }

    private YWTLogServiceBlockingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected YWTLogServiceBlockingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new YWTLogServiceBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     * 记录日志
     * </pre>
     */
    public com.ywt.gapi.base.log.SaveCommentLogResponse saveCommentLog(com.ywt.gapi.base.log.SaveCommentLogRequest request) {
      return blockingUnaryCall(
          getChannel(), METHOD_SAVE_COMMENT_LOG, getCallOptions(), request);
    }

    /**
     * <pre>
     * 保存his外转处方日志
     * </pre>
     */
    public com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse saveOpenHisPushApiLog(com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest request) {
      return blockingUnaryCall(
          getChannel(), METHOD_SAVE_OPEN_HIS_PUSH_API_LOG, getCallOptions(), request);
    }
  }

  /**
   * <pre>
   *医务通日志服务  // 对应 base-service 项目的 log.js 文件
   * </pre>
   */
  public static final class YWTLogServiceFutureStub extends io.grpc.stub.AbstractStub<YWTLogServiceFutureStub> {
    private YWTLogServiceFutureStub(io.grpc.Channel channel) {
      super(channel);
    }

    private YWTLogServiceFutureStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected YWTLogServiceFutureStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new YWTLogServiceFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     * 记录日志
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.ywt.gapi.base.log.SaveCommentLogResponse> saveCommentLog(
        com.ywt.gapi.base.log.SaveCommentLogRequest request) {
      return futureUnaryCall(
          getChannel().newCall(METHOD_SAVE_COMMENT_LOG, getCallOptions()), request);
    }

    /**
     * <pre>
     * 保存his外转处方日志
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse> saveOpenHisPushApiLog(
        com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest request) {
      return futureUnaryCall(
          getChannel().newCall(METHOD_SAVE_OPEN_HIS_PUSH_API_LOG, getCallOptions()), request);
    }
  }

  private static final int METHODID_SAVE_COMMENT_LOG = 0;
  private static final int METHODID_SAVE_OPEN_HIS_PUSH_API_LOG = 1;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final YWTLogServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(YWTLogServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SAVE_COMMENT_LOG:
          serviceImpl.saveCommentLog((com.ywt.gapi.base.log.SaveCommentLogRequest) request,
              (io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveCommentLogResponse>) responseObserver);
          break;
        case METHODID_SAVE_OPEN_HIS_PUSH_API_LOG:
          serviceImpl.saveOpenHisPushApiLog((com.ywt.gapi.base.log.SaveOpenHisPushApiLogRequest) request,
              (io.grpc.stub.StreamObserver<com.ywt.gapi.base.log.SaveOpenHisPushApiLogResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class YWTLogServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    YWTLogServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.ywt.gapi.base.log.Log.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("YWTLogService");
    }
  }

  private static final class YWTLogServiceFileDescriptorSupplier
      extends YWTLogServiceBaseDescriptorSupplier {
    YWTLogServiceFileDescriptorSupplier() {}
  }

  private static final class YWTLogServiceMethodDescriptorSupplier
      extends YWTLogServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    YWTLogServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (YWTLogServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new YWTLogServiceFileDescriptorSupplier())
              .addMethod(METHOD_SAVE_COMMENT_LOG)
              .addMethod(METHOD_SAVE_OPEN_HIS_PUSH_API_LOG)
              .build();
        }
      }
    }
    return result;
  }
}
